// WinGL L1 0.11e
//
// WinGL𗘗pPȃvO\[X
// $Header: /WinGL/SIMPLE/SIMPLE.CPP 12    97/02/01 7:05 Koizuka $
//
#include <string.h>
#include <windows.h>
#pragma hdrstop
#include "WinGL.h"
#include "game.h"
#include "simple.h"
#include "simple.dah"

#define RESDAR 0  /* 0ȂDARt@C, 1Ȃ烊\[Xp^[o^ */

//
// DAR Resource (RESDAR1̂ƂɎg)
//
#define RESOURCE_TYPE "DAR"
#define RESOURCE_NAME "SIMPLE_DAR"
// DAR\[XgꍇAɁAsimple.rĉقKv܂ /

//
// p^[ԍ
//
#define DAR_BALL 0
#define DAR_BACK 1
#define DAR_ARROW 2

//
// local class..
//
struct CHARACTER {
	int x,y ;
	int patnum ;
} ;

//
// class derrived GApp
//
class SimpleApp : public GApp {
public:
	SimpleApp(HINSTANCE hInst,HINSTANCE hPrev, LPSTR szCmdLine, int sw) ;
} ;

//
// class derrived GGameWindow
//
class SimpleWindow : public GGameWindow {
	WINGL Canvas;           // `
	GInputObject Input;     // ͑u

	enum TGameState { GS_TITLE, GS_GAME } GameState ;
	CHARACTER MyChar ;      // LN^
	int patPause ;          // 'Pause'
	int patCopyright ;
	BOOL bFullscreen;

public:
	BOOL FullScreenMode(BOOL full);
	static int SIZEX, SIZEY ;
	static const int MOVE_STEP;
	static const int TIMEOUT;

	static char * getClassName() {
		// Windows"WindowNX"ԂB
		// ɂ̓AvP[V킩悤ȖOꂽقǂł傤
		//
		return "SimpleWindow";
	}
	static char * getMenuName() {
		// menu\[XԂBmenuȂȂNULL
		// j[gꍇAɃj[\[XĂB
		// ȂAwb_ɒ萔ƂĒ`ꍇ MAKEINTRESOURCE(MENU_1) ̂悤
		// Kv܂B
		//
		return NULL;
	}

	static BOOL RegisterClass() {
		// ̓EBhENXX^Cݒ肷Kvꍇ
		// 邱ƂxłB
		// ȂAO}EXJ[\`sȂꍇ
		// }EXJ[\(ANeBu)̍s܂邲ƃRgɂĂB
		//
		return Register(
			getClassName(),
			LoadCursor(NULL,IDC_ARROW),	            // }EXJ[\(ʏ)
			NULL,	                                // }EXJ[\(ANeBu)̓iV 
			LoadIcon(MainApp->getInstance(),"AppIcon"),   // icon
			getMenuName(),                          // menu name
			0, // (HBRUSH)(COLOR_WINDOW + 1),       // wiuV, 0ȂiV
			// LwiuV́AAvP[VEBhEŜhƂ 0 ɂB 
			CS_DBLCLKS                              // class style
		);
	}

private:
	//
	void GameStart() ;

	void TitleGameProc(HDC) ;
	void InGameProc(HDC hdc) ;


	// override function..
	virtual LRESULT OnCommand(short wNotifyCode, short wId, HWND hwndCtl) ;
	virtual void OnPaint(HDC hdc) ;

	virtual void OnKeyDown( int wVKey, DWORD ) ;

	virtual void OnPause(int lastpause) ;
	virtual BOOL OnPeriod(HDC hdc, UINT drop) ;

	virtual void OnCursorChange();
	virtual void OnRButtonDown( WPARAM fwKey, WORD x, WORD y ) ;

public:
	SimpleWindow( int x, int y, HWND hwndParent = 0) ;
} ;

//
// Implementation...
//
 int SimpleWindow::SIZEX = 400;                // `ʂ̑傫
 int SimpleWindow::SIZEY = 300;

const int SimpleWindow::MOVE_STEP = 7;              // ړP

const int SimpleWindow::TIMEOUT = 25 ;				// b40̕`

void SimpleWindow::GameStart() {
	MyChar.x = SIZEX / 2 ;
	MyChar.y = SIZEY / 2 ;
	MyChar.patnum = DAR_BALL ;

	GameState = GS_GAME ;
}

// Q[CłȂƂɂԂĂ΂鏈ꍇ
void SimpleWindow::TitleGameProc(HDC) {
}

// Q[ĈƂɂԂĂ΂鏈
void SimpleWindow::InGameProc(HDC hdc ) {
	int x = MyChar.x ;
	int y = MyChar.y ;

	GInputState stick(Input);	// XeBbN(L[)ǂ
	// LN^𓮂

	// ̂悤ɕďƂŁAΌ̃L[𗼕Ƃɒ~܂ /
	if ( stick.left() ) {  // ..
		x -= MOVE_STEP;
	}
	if ( stick.right()  ) { // E..
		x += MOVE_STEP;
	}
	if ( stick.up() ) { // ..
		y -= MOVE_STEP ;
	}
	if ( stick.down() ) { // ..
		y += MOVE_STEP ;
	}

	// E̍s␳
	if ( x < 0 )
		x = 0;
	else if ( x >= SIZEX )
		x = SIZEX - 1;
	// ㉺B
	if ( y < 0 )
		y = 0 ;
	else if ( y >= SIZEY )
		y = SIZEY-1 ;

	// LN^̈ʒuɔf
	MyChar.x = x ;
	MyChar.y = y ;

	// ̈ړI`悵悤

	// Swi`
	WGLDRAWSTRUCT dst;
	dst.flags = 0;
	dst.patnum = DAR_BACK;
	for ( int iy = 0 ; iy < SIZEY ; iy += PatSizeY(DAR_BACK) ) {
		for ( int ix = 0 ; ix < SIZEX ; ix += PatSizeX(DAR_BACK) ) {
			dst.x = ix;
			dst.y = iy;
			Canvas.Draw( &dst );
		}
	}

	// LN^`
	dst.x = MyChar.x - PatSizeX(MyChar.patnum)/2;
	dst.y = MyChar.y - PatSizeY(MyChar.patnum)/2;
	dst.patnum = MyChar.patnum;
	dst.flags = 0;
	Canvas.Draw( &dst );

	if ( patCopyright >= 0 ) {
		// ""
		dst.x = Canvas.Width() - PatSizeX(patCopyright);
		dst.y = Canvas.Height() - PatSizeY(patCopyright);
		dst.patnum = patCopyright;
		Canvas.Draw( &dst );
	}

	// }EXJ[\Oŕ`
	if ( GetCursor() == 0 ) { // }EXJ[\Ă邱ƂmF̏
		POINT pt;
		GetCursorPos(&pt);
		ScreenToClient(&pt);

		// WinGL{␳
		int z = Canvas.zoom * 2;
		if ( z == 0 ) z = 1;
		pt.x = pt.x * 2 / z;
		pt.y = pt.y * 2 / z;
		//
		dst.x = pt.x ;
		dst.y = pt.y ;
		dst.zoomx = dst.zoomy = pt.x + 128;
		dst.flags = WDS_NORMAL; /* WDS_ZOOMX|WDS_ZOOMY|WDS_FLIPX; */
		dst.patnum = DAR_ARROW;

		Canvas.Draw( &dst );

		// ̂ƂɈʒuJ[\ʒuɊ
		if ( pt.x > MyChar.x )
			MyChar.x += 3;
		else if ( pt.x < MyChar.x )
			MyChar.x -= 2;
		if ( pt.y > MyChar.y )
			MyChar.y += 3;
		else if ( pt.y < MyChar.y )
			MyChar.y -= 2;
		// ̂悤ɁA+-̒l1炷ƁAړI̒n_ɂƂɈUĈ肷̂
		// @BIł()
	}

	// ʂ֓]

	Canvas.Paint(hdc);
} // InGameProc

// IɌĂяo //
// ̎́AStartPeriod()Ŏw肳B
// ̃vȌꍇ TIMEOUT ɐݒ肳Ă鎞(~bP)ŌĂ΂B
BOOL SimpleWindow::OnPeriod(HDC hdc, UINT ) {
	switch (GameState) {
	case GS_TITLE:
		TitleGameProc(hdc);
		break;
	case GS_GAME:
		InGameProc(hdc);
	  break;
	}
	return TRUE;
}

// j[IꂽȂ //
LRESULT SimpleWindow::OnCommand(short, short wId, HWND ) {
	switch(wId) {
	case MENU_ABOUT: /* IDD_ABOUT̃_CAO\ */
		MainApp->AboutBox( MAKEINTRESOURCE(IDD_ABOUT), getHWND() );
		break;
	}
	return 0L;
}


// ق̃EBhEɉBĂꂽƂp̕` //
// ͉Kv͂܂B
void SimpleWindow::OnPaint(HDC hdc) {
	Canvas.Paint(hdc,0,0);
}

// |[Y/Ԃ̕ω //
void SimpleWindow::OnPause(int lastpause) {
	if ( (lastpause ^ GetPause() ) & 2 ) {
		if ( GetPause() & 2 ) {
			// |[Y //
			//Canvas.Clear(0) ;    // black
			int pat = patPause ;
			if ( pat < 0 ) {
				HDC hdc = Canvas.GetDC();
				TextOut(hdc, 0,0,"Pause",5);
				Canvas.ReleaseDC();
			} else {
				Canvas.PatPut( (Canvas.Width() - PatSizeX(pat))/2, (Canvas.Height() - PatSizeY(pat))/2, pat );
			}
			InvalidateRect(0, 0);
		} else {
			// ĊJ //
		}
	}
}

// J[\ω
void SimpleWindow::OnCursorChange() {
	if ( GetCursor() ) {
		// J[\̂ŁAOJ[\
		HDC hdc = GetDC();
		/* ʂ̐F\Ȃ */
		if (hpal && !__WinGLNoSelectPalette)
			SelectPalette(hdc,hpal,FALSE);
		RealizePalette(hdc);
		OnPeriod(hdc,0);  /* ̒ŎOJ[\ʍXVs */
		ReleaseDC(hdc);
	}
}

// }EXE{^ꂽ
void SimpleWindow::OnRButtonDown( WPARAM , WORD , WORD  ) {
	FullScreenMode( !bFullscreen );
}

// L[ꂽ //
void SimpleWindow::OnKeyDown( int wVKey, DWORD ) {
	switch ( wVKey ) {
	case VK_F4:
		FullScreenMode( !bFullscreen );
		break;

	case VK_F3:
	case VK_ESCAPE :
		// F3, ESCL[Ń|[Y/ĊJ //
		SetPause(GetPause() == 0);
	}
}

//
// p^[Ƃēo^
//
// :
//   hdc   CreateCompatibleDC(0)ō쐬A\tHgSelectObjectHDC
//   text  
//   color  0`255ŐFw肷
// 
int WINGLAPI CreateTextPat( HDC hdc, LPCSTR text, int color ) {
	SIZE size;
	int patnum;
	size.cx = size.cy = 0;
#if WINGL32
	if ( !GetTextExtentPoint32(hdc, text, lstrlen(text), &size ) )
#endif
	  if ( !GetTextExtentPoint(hdc, text, lstrlen(text), &size ) )
		return -1;

	WGLLOCK2 lock;
	patnum = PatAlloc2(&lock, WinGLPatNum, size.cx, size.cy, NULL, PAL_BLACK /*h*/, PAL_BLACK /**/ );
	if ( patnum >= 0 ) {
		TextDraw2( &lock, hdc, 0, 0, text, color );
		PatUnlock2( &lock, patnum );
	}
	return patnum;
}

//
// Sʃ[hON/OFF
//
BOOL SimpleWindow::FullScreenMode(BOOL full) {
	if ( full ) {
		SIZEX = 640;
		SIZEY = 480;
		Canvas.Size(SIZEX,SIZEY,0);

		// EBhE̕`̈̑傫ݒ
		//
		if ( WinGLScreenMode(&Canvas, WGL_FULLSCREEN) ) {
			// LvV
			SetStyle( GetStyle() & ~WS_CAPTION );
			bFullscreen = TRUE;
			return TRUE; /*  */
		}
#if 0
		// tXN[Ɠ傫̑ɂꍇ
		SetClientSize(SIZEX,SIZEY);
		bFullscreen = TRUE;
		return TRUE;
#endif
	}

	// EBhEw肵ꍇ, уtXN[sꍇ

	SIZEX = 400;
	SIZEY = 300;
	Canvas.Size(SIZEX,SIZEY,0);

	// EBhE[hɂ
	//
	WinGLScreenMode(&Canvas, WGL_WINDOW);

	// LvVt
	SetStyle( GetStyle() | WS_CAPTION );

	// Window[hɂĂAWindow̕`̈̑傫ݒ肷
	// ~~~~~~~~~~~~~~~~~~~~~~
	SetClientSize(SIZEX,SIZEY);

	bFullscreen = FALSE;
	return FALSE;
}

//
// Window쐬
//
SimpleWindow::SimpleWindow( int x, int y, HWND hwndParent) :
 GameState(GS_TITLE), Input(GInputObject::Template1P), patPause(-1), patCopyright(-1),
 GGameWindow( "WinGL Simple Sample", getClassName(), 
 WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX, x,y,
 CW_USEDEFAULT,0, hwndParent), Canvas(getHWND()) {

	if ( isOk() ) {
		// zVRAM̏
		//
		Canvas.Size(SIZEX, SIZEY, 0, hpal) ;
		Canvas.Clear(0) ;    // black

		// ̓o^
		//
		HDC hdc = CreateCompatibleDC(0);
		HFONT hlastfont = (HFONT)SelectObject(hdc, CreateFont(24,0,0,0,FW_DONTCARE,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_MODERN | 4 /*TrueType*/, "" ));
		patPause = CreateTextPat( hdc, "ꎞ~", PAL_WHITE );

		DeleteObject( SelectObject(hdc, CreateFont(24,0,0,0,FW_DONTCARE,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_ROMAN | 4 /*TrueType*/, "" )));
		patCopyright = CreateTextPat( hdc, "", PAL_YELLOW );

		DeleteObject( SelectObject(hdc, hlastfont ) );
		DeleteDC(hdc);

		// VXej[Aboutǉ
		//
		GMenu menu(GetSystemMenu(FALSE));
		menu.AppendSeparator();
		menu.AppendString(MENU_ABOUT, "About...");

		// Jn̂߂̐ݒ菈ł
		GameStart();
	}
}


//
// SimpleApp Implementation
//
SimpleApp::SimpleApp(HINSTANCE hInst,HINSTANCE hPrev, LPSTR szCmdLine, int sw)
 : GApp(hInst,hPrev,szCmdLine,sw) {

	isok = FALSE;
	if ( !hPrev ) {
		if ( !SimpleWindow::RegisterClass() )
			return;
	}

	//
	// N̏̓RR
	// sAreturn Ηǂ
	//
	// : ܂CreateWindowĂȂ̂ŁAEBhEɊ֘AƂ
	//         SimpleWindow::SimpleWindowłĂ
	//

#if RESDAR
	if ( PatEntryDAR( 0, DAR_SIMPLE_TOTAL, hInst, RESOURCE_NAME, RESOURCE_TYPE, NULL ) < DAR_SIMPLE_TOTAL ) {
		MessageBox(0, "!PatEntryDAR", 0, MB_ICONSTOP|MB_OK );
		return;
	}
#else
	if ( PatEntryDARFile( 0, DAR_SIMPLE_TOTAL, "simple.DAR" ) < DAR_SIMPLE_TOTAL ) {
		return;
	}
#endif

	// ̂
	isok = TRUE;
}

int PASCAL WinMain(HINSTANCE hInst, HINSTANCE hPrev, LPSTR szCmdLine, int sw) {
	// AvP[V
	SimpleApp App(hInst,hPrev,szCmdLine,sw);
	if ( !App.isOk() ) { // 玸s
		//
		// Ȃɕse؂CJ
		//
		MessageBox(0, "NɎs܂B", 0, MB_ICONSTOP|MB_OK );
		return FALSE;
	}

	// EBhEJ
	SimpleWindow Window(CW_USEDEFAULT, 0 );
	if ( !Window.isOk() ) { // 玸s
		//
		// CJCJ
		//
		MessageBox(0, "EBhEJȂ悤", 0, MB_ICONSTOP|MB_OK );
		return FALSE;
	}

	// ĕ\ON!
#if 0
	// ȂtXN[ɂꍇ(łȂ΃EBhE\)
	if ( !Window.FullScreenMode( TRUE ) ) {
		Window.Show(sw);
	}
#else
	// ʂɃEBhEԂŋNꍇ
	Window.FullScreenMode( FALSE ); // EBhȆ傫ݒ
	Window.Show(sw);
#endif

	Window.StartPeriod( SimpleWindow::TIMEOUT,0 ) ;  // ɂOnPeriodԂĂ΂悤ɂȂ

	// ēJnB
	return App.MessageLoop();
}
